#include<stdio.h>
int main(){
	long long int a,b;
	scanf("%lld %lld",&a,&b);
	long long int mat[a][b];
	for(long long int i=0;i<a;i++){
		for(long long int j=0;j<b;j++){
			scanf("%lld",&mat[i][j]);
		}
	}

	long long int q;
	scanf("%lld",&q);
	long long x[q],y[q];
	for(long long int i=1;i<=q;i++){
		scanf("%lld %lld",&x[i],&y[i]);
	}
	long long int br=0,i=1,j=1;

	for(long long int k=1;k<=q;k++){
		
		j=0;
		i=0;
		br=mat[i][j];
		
		while(j!=b-1||i!=a-1){
			while(j!=b-1){
				j++;
				if(j==y[k]-1&&i==x[k]-1){
					i++;
					j--;
				}
				br+=mat[i][j];
				
			}
			while(i!=a-1){
				i++;
				if(j==y[k]-1&&i==x[k]-1){
					i--;
					br-=mat[i][j];
					j--;
					i++;
					
				}
				br+=mat[i][j];
				
			}
	}
			
		
		printf("%lld\n",br);
		
	}
	
}